SystemOrganization addCategory: #'OB-Tests-Core'!

ProtoObject subclass: #OBMessageRecorder
	instanceVariableNames: 'mock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBMessageRecorder class methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 00:25'!
forMock: aMock
	^ self new obmrSetMock: aMock! !

!OBMessageRecorder methodsFor: 'debugging' stamp: 'cwp 2/29/2004 15:52'!
asExplorerString
	^ 'an OBMessageRecorder'! !

!OBMessageRecorder methodsFor: 'recording' stamp: 'cwp 2/28/2004 17:23'!
doesNotUnderstand: aMessage
	^ mock message: aMessage! !

!OBMessageRecorder methodsFor: 'debugging' stamp: 'cwp 2/29/2004 15:53'!
hasContentsInExplorer
	^ false! !

!OBMessageRecorder methodsFor: 'debugging' stamp: 'cwp 2/13/2004 01:14'!
inspectorClass
	^ Inspector! !

!OBMessageRecorder methodsFor: 'debugging' stamp: 'cwp 3/17/2004 00:00'!
isMorph
	^ false! !

!OBMessageRecorder methodsFor: 'initializing' stamp: 'cwp 2/13/2004 00:24'!
obmrSetMock: aMockObject
	mock _ aMockObject! !

!OBMessageRecorder methodsFor: 'recording' stamp: 'cwp 9/18/2005 10:25'!
perform: aSelector withArguments: anArray
	mock message: (Message selector: aSelector arguments: anArray)! !

!OBMessageRecorder methodsFor: 'debugging' stamp: 'cwp 9/18/2005 10:22'!
respondsTo: aSelector
	^ true! !

OBBrowser subclass: #OBFakeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBFakeBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2007 00:18'!
cmdBeZ
	^ OBPluggableCommand new
		label: 'become z';
		active: [:node :col | col isSelected: node];
		action: [:node :col | node beZ. node announceChangedWith: col];
		yourself! !

!OBFakeBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2007 00:34'!
cmdCreateZ
	^ OBPluggableCommand new
		label: 'create z';
		action: [:node :col | node createZ announceSelectionWith: col];
		active: [:node :col | (col isSelected: node) not];
		yourself! !

!OBFakeBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2007 00:20'!
cmdDelete
	^ OBPluggableCommand new
		label: 'delete';
		action: [:node :col | node delete. node announceDeletionWith: col];
		active: [:node :col | col isSelected: node];
		yourself! !

!OBFakeBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2007 00:24'!
cmdDeleteRoot
	^ OBPluggableCommand new
		label: 'delete root';
		action: [:node :col | node root announceDeletionWith: col];
		active: [:node :col | col isSelected: node];
		yourself! !

OBBrowser subclass: #OBFakeCommandBrowser
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBFakeCommandBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 10/4/2006 10:04'!
defaultMetaNode
	^ OBFakeNode metagraph! !

!OBFakeCommandBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 10/4/2006 10:04'!
defaultRootNode
	^ OBFakeNode new! !

!OBFakeCommandBrowser class methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2007 19:22'!
withAction: aBlock
	| browser |
	browser _ self basicNew initialize.
	browser action: aBlock.
	self panels do: [:ea | browser addPanel: ea].
	browser setMetaNode: self defaultMetaNode node: self defaultRootNode.
	^ browser! !

!OBFakeCommandBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 10/4/2006 09:59'!
action
	^ action! !

!OBFakeCommandBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 10/4/2006 09:59'!
action: aBlock	
	action _ aBlock! !

!OBFakeCommandBrowser methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2007 19:04'!
cmdPluggable
	^ OBPluggableCommand action: action! !

TestCase subclass: #OBAnnouncerTest
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBAnnouncerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/3/2006 21:21'!
testBlock
	| announcement |
	announcer _ OBAnnouncer new.
	announcer
		observe: OBSelectionChanged
		do: [:arg | announcement _ arg].
	announcer announce: OBSelectionChanged.
	self assert: (announcement isKindOf: OBSelectionChanged)! !

!OBAnnouncerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/3/2006 21:21'!
testInstance
	| announcement |
	announcer _ OBAnnouncer new.
	announcer
		observe: OBSelectionChanged
		do: [:arg | announcement _ arg].
	announcer announce: OBSelectionChanged new.
	self assert: (announcement isKindOf: OBSelectionChanged)! !

!OBAnnouncerTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/3/2006 21:22'!
testMessage
	| announcement |
	announcer _ OBAnnouncer new.
	announcer
		observe: OBSelectionChanged
		send: #value:
		to: [:ann | announcement _ ann].
	announcer announce: OBSelectionChanged.
	self assert: (announcement isKindOf: OBSelectionChanged)! !

TestCase subclass: #OBBarMorphTest
	instanceVariableNames: 'bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBBarMorphTest methodsFor: 'simulating' stamp: 'cwp 3/11/2007 15:51'!
push: aString
	| button |
	button _ bar submorphs detect: [:b | b label contents = aString].
	button performAction! !

OBBarMorphTest subclass: #OBButtonBarTest
	instanceVariableNames: 'received'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBButtonBarTest class methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2007 17:03'!
openBar
	self new setUp; openBarInWorld! !

!OBButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 3/11/2007 16:52'!
cmd1
	received _ #cmd1! !

!OBButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 3/11/2007 17:30'!
cmd3
	received = #cmd3! !

!OBButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 3/11/2007 21:03'!
color
	^ Color red! !

!OBButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 3/11/2007 21:05'!
commands
	^ 	{(OBPluggableCommand action: [self cmd1])
			label: 'Command 1'.
		(OBPluggableCommand action: [self cmd3])
			label: 'Command 3'.
		(OBPluggableCommand action: [self cmd4])
			label: 'Command 4';
			active: [false]}! !

!OBButtonBarTest methodsFor: 'running' stamp: 'cwp 3/11/2007 17:02'!
openBarInWorld
	bar openInWorld.
	self changed: #commands.
	bar bounds: (100@100 corner: 400@140).
! !

!OBButtonBarTest methodsFor: 'running' stamp: 'cwp 3/11/2007 15:56'!
setUp
	bar _ OBButtonBar on: self.
	
			! !

!OBButtonBarTest methodsFor: 'testing' stamp: 'cwp 3/11/2007 17:02'!
testLayout
	| rects |
	
	"This is an ugly hack. I can't figure out how else to force a layout."
	self openBarInWorld.
	bar delete.

	rects _ bar submorphs collect: [:b | b bounds].
	self assert: rects first left = bar left.
	self assert: rects first right = rects second left.
	self assert: rects second right = rects third left.
	self assert: rects third right = bar right.
! !

!OBButtonBarTest methodsFor: 'testing' stamp: 'cwp 3/11/2007 16:53'!
testPush1
	self push: 'Command 1'.
	self assert: received = #cmd1! !

!OBButtonBarTest methodsFor: 'testing' stamp: 'cwp 3/11/2007 17:06'!
testPush4
	self push: 'Command 4'.
	self assert: received isNil! !

OBBarMorphTest subclass: #OBRadioButtonBarTest
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBRadioButtonBarTest methodsFor: 'asserting' stamp: 'cwp 11/27/2004 18:03'!
assertSelectionIs: anInteger
	self assert: selection = anInteger.
	bar submorphs withIndexDo: 
		[:button :index |
		index = anInteger
			ifTrue: [self assert: button isOn]
			ifFalse: [self deny: button isOn]]! !

!OBRadioButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 2/22/2004 17:42'!
list
	^ #('alpha' 'beta' 'gamma')! !

!OBRadioButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 2/22/2004 16:39'!
selection
	^ selection! !

!OBRadioButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 2/24/2004 19:31'!
selection: anInteger
	selection _ anInteger.
	self changed: #selection! !

!OBRadioButtonBarTest methodsFor: 'running' stamp: 'cwp 11/27/2004 18:03'!
setUp
	selection _ 0.
	bar _ OBRadioButtonBar
			on: self
			list: #list
			selected: #selection
			changeSelected: #selection:.
! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 3/11/2007 15:57'!
testLayout
	| rects |
	
	"This is an ugly hack. I can't figure out how else to force a layout."
	bar openInWorld.
	self changed: #list.
	bar bounds: (100@100 corner: 400@140).
	bar delete.

	rects _ bar submorphs collect: [:b | b bounds].
	self assert: rects first left = bar left.
	self assert: rects first right = rects second left.
	self assert: rects second right = rects third left.
	self assert: rects third right = bar right.
! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 2/22/2004 16:53'!
testList
	self assert: bar list = self list! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 2/24/2004 19:35'!
testPushAlphaBeta
	self changed: #list.
	self push: 'alpha'.
	self assertSelectionIs: 1.
	self push: 'beta'.
	self assertSelectionIs: 2.! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 11/27/2004 18:04'!
testUpdateList
	| labels |
	self changed: #list.
	labels _ bar submorphs collect: [:b | b label contents].
	self assert: labels size = self list size.
	self assert: (labels includesAllOf: self list)! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 2/24/2004 19:15'!
testUpdateSelection
	self changed: #list.
	selection _ 2.
	self changed: #selection.
	self assertSelectionIs: 2.! !

TestCase subclass: #OBBrowserCommandsTest
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBBrowserCommandsTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2007 00:46'!
test01ScanFindsCommandCreationMethods
	| called scan |
	called := false.
	browser := OBFakeCommandBrowser withAction: [called := true].
	scan := browser announce: OBNodeCommandScan.
	(scan commandsOn: nil for: nil) first execute.
	self assert: called! !

TestCase subclass: #OBBrowserTest
	instanceVariableNames: 'model morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:13'!
isAbstract
	^ self name = #OBBrowserTest! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 9/14/2005 22:22'!
assertAListIncludes: anArrayOfStrings
	self listMorphs 
			detect: [:m | | list |
					list _ m getListDelicately collect: [:ea | ea  asString withBlanksTrimmed].
					list includesAllOf: anArrayOfStrings]
			ifNone: [self assert: false].! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 3/14/2004 13:10'!
assertAListMatches: strings
	| list |
	self listMorphs
			detect:	[:m | 
					list _ m getListDelicately.
					(list size = strings size) and: [list includesAllOf: strings]]
			ifNone: [self assert: false].! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 3/11/2004 23:03'!
assertButtonSelected: aString
	| button |
	button _ (self morphsOfClass: PluggableButtonMorph) 
				detect: [:m | m label contents = aString]
				ifNone: [self signalFailure: 'No button labeled ', aString].
	self assert: button isOn! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/8/2005 12:01'!
assertCurrentItemIs: aString
	self assert: self currentItem withBlanksTrimmed = aString! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 3/14/2004 12:47'!
assertListAt: index contains: items
	| list |
	list _ self listItemsAt: index.
	self assert: (list size = items size).
	self assert: (list includesAllOf: items).! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 9/14/2005 23:05'!
assertListAt: index includes: items
	| list |
	list _ (self listItemsAt: index) collect: [:ea | ea asString withBlanksTrimmed].
	self assert: (list includesAllOf: items).! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/23/2004 22:35'!
assertMenuContains: aString
	| item |
	item _ self menuItemNamed: aString.
	self assert: item notNil! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 12/10/2004 21:39'!
assertNoButtonsVisible
	self assert: ((morph submorphNamed: 'scroller') 
					submorphOfClass: PluggableButtonMorph) isNil.! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 2/29/2004 19:38'!
assertSelectedTextIs: aString
	| text selection |
	morph _ self textMorph.
	text _ morph getText.
	selection _ morph getSelection.
	self assert: (text atAll: selection) asString = aString.! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 3/16/2004 20:33'!
assertTextIs: aString
	| actual |
	actual _ self textMorph text.
	self assert: actual = aString.! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 2/29/2004 19:33'!
assertTextIsSelected
	self assert: self textMorph getSelection size = self textMorph getText size! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 3/11/2004 23:02'!
clickButtonLabeled: aString
	| button |
	button _ (self morphsOfClass: PluggableButtonMorph) 
				detect: [:m | m label contents = aString]
				ifNone: [self signalFailure: 'No button labeled ', aString].
	button performAction! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 9/14/2005 22:22'!
currentItem
	^ self currentList selection asString! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 5/13/2004 10:59'!
currentList
	^ self listMorphs reversed 
						detect: [:list | list selection notNil]
						ifNone: [self signalFailure: 'No item is currently selected']! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 3/14/2004 13:11'!
denyAListIncludes: anArrayOfStrings
	self listMorphs 
			detect: [:m | m getListDelicately includesAllOf: anArrayOfStrings]
			ifNone: [^ self].
	self assert: false.! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
deselect: aString
	| listMorph |
	listMorph _ self findListContaining: aString.
	listMorph changeModelSelection: 0.! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/28/2004 13:50'!
drag: nodeName
	| item list |
	item _ StringMorph contents: nodeName asString.
	list _ self findListContaining: nodeName.
	^ list model dragPassengerFor: item inMorph: list! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/28/2004 13:50'!
drag: passangerName to: targetName
	| passanger |
	passanger _ self drag: passangerName.
	self drop: passanger on: targetName! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/28/2004 13:50'!
drop: aPassenger on: targetName
	| list transfer event |
	list _ self findListContaining: targetName.
	self assert: list notNil.
	transfer _ TransferMorph withPassenger: aPassenger.
	transfer dragTransferType: #OmniBrowser.
	event _ self mouseMoveEventIn: targetName.
	self assert: (list model wantsDroppedMorph: transfer event: event inMorph: list).
	^ list model acceptDroppingMorph: transfer event: event inMorph: list! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/28/2004 13:52'!
editText: aString
	| textMorph |
	textMorph _ self textMorph.
	textMorph 
		selectAll;
		replaceSelectionWith: aString asText! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 9/14/2005 09:00'!
findListContaining: aString
	^ self listMorphs 
		detect: [:m | | list |
				list _ m getListDelicately collect: [:ea | ea asString withBlanksTrimmed].
				list includes: aString] 
		ifNone: [nil]! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 11/17/2004 23:45'!
forceLayout
	morph bounds: (6@6 corner: 606@406)! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 3/14/2004 13:11'!
listItemsAt: index
	^ (self listMorphs 
		at: index 
		ifAbsent: [self signalFailure: 'List ', index asString, ' does not exist'])
			getListDelicately
	! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
listMorphs
	^ self morphsOfClass: PluggableListMorph! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 1/26/2004 21:53'!
menuItemNamed: aString
	| lists current |
	lists _ self listMorphs.
	current _ lists reversed detect: [:list | list selection notNil].
	^ (current getMenu: true) itemWithWording: aString.
! !

!OBBrowserTest methodsFor: 'running' stamp: 'avi 9/17/2005 01:39'!
metagraph
	^ self browserClass defaultMetaNode! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
morphNamed: aString
	^ morph 
		findDeepSubmorphThat: [:m | m knownName = aString]
		ifAbsent: [self signalFailure: aString, 'not found']! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
morphsOfClass: aClass
	| found |
	found _ OrderedCollection new.
	morph allMorphsDo: [:m | (m isMemberOf: aClass) ifTrue: [found add: m]].
	^ found! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 3/14/2004 13:14'!
mouseMoveEventIn: name
	| rect plm |
	plm _ self findListContaining: name.
	rect _ plm listMorph rectForRow: (plm getListDelicately indexOf: name).
	^ MouseMoveEvent new
		setType: #mouseEnter
		startPoint: rect center + (rect width @ 0)
		endPoint: rect center
		trail: #()
		buttons: 4
		hand: ActiveHand
		stamp: Time millisecondClockValue! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 9/14/2005 09:01'!
select: aString
	"We don't use #getListDelicately because the user would have to scroll through the list
	to find the item we're selecting, thus triggering updates to the list."
	
	| listMorph list |
	listMorph _ self findListContaining: aString.
	self assert: listMorph notNil.
	listMorph model okToChange ifFalse: [^ self].
	list _ listMorph getListObtrusively collect: [:ea | ea asString withBlanksTrimmed].
	listMorph changeModelSelection: (list indexOf: aString)! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 1/23/2004 23:30'!
selectMenuItem: aString
	| item |
	item _ self menuItemNamed: aString.
	item ifNil: [self signalFailure: 'Menu item ''', aString, ''' does not exist.'].
	item doButtonAction! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 3/14/2004 13:46'!
selectSequence: aCollection
	| plm |
	aCollection withIndexDo: [:item :index | 
					plm _ self listMorphs at: index.
					plm changeModelSelection: (plm getListObtrusively indexOf: item)]! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
setText: aString
	| textMorph |
	textMorph _ self textMorph.
	textMorph 
		selectAll;
		replaceSelectionWith: aString asText;
		accept.
	! !

!OBBrowserTest methodsFor: 'running' stamp: 'cwp 12/5/2004 18:16'!
setUp
	model _ self browserClass metaNode: self metagraph node: self node.
	morph _ model morph.
	self forceLayout! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 11/6/2004 23:00'!
textMorph
	^ (self morphsOfClass: OBPluggableTextMorph) last! !

OBBrowserTest subclass: #OBFakeBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBFakeBrowserTest methodsFor: 'constants' stamp: 'cwp 3/12/2007 23:51'!
browserClass
	^ OBFakeBrowser! !

!OBFakeBrowserTest methodsFor: 'running' stamp: 'cwp 11/7/2004 21:27'!
metagraph
	^ OBFakeNode metagraph! !

!OBFakeBrowserTest methodsFor: 'running' stamp: 'cwp 12/17/2003 15:12'!
node
	^ OBFakeNode new! !

!OBFakeBrowserTest methodsFor: 'constants' stamp: 'cwp 12/5/2004 18:17'!
paneCount
	^ 4! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 3/14/2004 14:25'!
testAcceptText
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'.
	self setText: 'x'.
	
	"This is a gratuitous refresh to make the test pass. It isn't necessary when the 
	browser is actually open. It's a deficiency of the test environment..."
	self listMorphs do: [:ea | ea update: #list].
	
	self assertListAt: 1 contains: #(x b c).
	self assertListAt: 2 contains: #(xa xb xc).
	self assertTextIs: 'x'
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/7/2004 08:27'!
testAction
	self select: #a.
	self selectMenuItem:  'become z'.
	self assertListAt: 1 contains:  #(z b c)! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/28/2004 13:49'!
testConfirmAbandon
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'.
	self editText: 'x'.
	[self select: #b]
		on: OBConfirmationRequest
		do: [:notification | notification cancel].
	self assertCurrentItemIs: #a.
	self assertTextIs: 'x'.
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 4/17/2006 22:14'!
testConfirmClose
	| notification |
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'.
	self editText: 'x'.
	[morph delete]
		on: OBConfirmationRequest
		do: [:ex | notification _ ex].
	self deny: notification isNil! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 11/23/2003 13:12'!
testCreateWindow
	self assert: (morph isKindOf: SystemWindow).
	self assert: (morph label = 'OmniBrowser').
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 6/4/2006 12:18'!
testDeleteB
	self select: #b.
	self selectMenuItem: 'delete'.
	self assertListAt: 1 contains: #(a c).
	self assert: self listMorphs size = self paneCount.
	self assertTextIs: ''.! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 3/14/2004 17:20'!
testDeleteRootNode
	self select: #a.
	self selectMenuItem: 'delete root'.
	self denyAListIncludes: #(a b c).
	self assertTextIs: ''! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 8/26/2004 02:17'!
testDeselectA
	self select: #a.
	self deselect: #a.
	self assertListAt: 1 contains: #(a b c).
	self assert: self listMorphs size = self paneCount.
	self assertTextIs: ''.! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 6/4/2006 13:30'!
testDragAndDrop
	| node |
	self select: #a.
	node _ self drag: #ab.
	self assert: (node isKindOf: OBFakeNode).
	self assert: node name = #ab.
	self drop: node on: #c.
	self assertListAt: 1 contains: #(a b c).
	self assertCurrentItemIs: #c.
	self assertTextIs: 'c'.
	self assertListAt: 2 contains: #(cb).
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 8/26/2004 02:17'!
testInitialDisplay
	self assert: self listMorphs size = self paneCount.
	self assertListAt: 1 contains: #(a b c).
	self assertTextIs: ''.
	! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 11/20/2004 21:00'!
testPanes
	| scroller |
	self 
		assert: (self morphsOfClass: PluggableListMorph) size = self paneCount.
	self assert: (self morphsOfClass: OBPluggableTextMorph) size = 1.
	scroller := self morphNamed: 'scroller'.
	self assert: scroller panes size = model navigationPanel minPanes! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 6/4/2006 13:29'!
testRefreshDirty

	self select: #a.
	self editText: 'x'.
	
	[self selectMenuItem: 'create z']
		on: OBConfirmationRequest
		do: [:request | request cancel].
	model announcer announce: (OBRefreshRequired new).
	
	self assertListAt: 1 contains: #(a b c z).
	self assertCurrentItemIs: #a.
	self assertTextIs: 'x'.
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:30'!
testSelectA
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:30'!
testSelectC
	self select: #c.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #().
	self assertTextIs: 'c'! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'dvf 9/5/2005 18:10'!
testSelectionPath
	self select: #a.
	self select: #ab.
	self assert: ((model selectionPath collect: [:e | e item]) = (OrderedCollection with: 'a' with: 'b'))! !

TestCase subclass: #OBColumnTest
	instanceVariableNames: 'announcer column'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBColumnTest methodsFor: 'support' stamp: 'cwp 11/2/2006 00:35'!
addFactory: aBlock 
	| factory |
	factory := OBPluggableCommand action: aBlock.
	announcer observe: OBNodeCommandScan do: [:ann | ann addFactory: factory].
	^factory! !

!OBColumnTest methodsFor: 'updating' stamp: 'cwp 10/14/2006 18:04'!
announce: aClass 
	^ announcer announce: aClass! !

!OBColumnTest methodsFor: 'emulating' stamp: 'cwp 6/25/2006 00:04'!
announcer
	^ announcer! !

!OBColumnTest methodsFor: 'emulating' stamp: 'cwp 6/25/2006 00:40'!
browser
	^ self! !

!OBColumnTest methodsFor: 'emulating' stamp: 'cwp 6/25/2006 00:39'!
parentNodeForColumn: aColumn
	^ OBFakeNode parent: nil item: 'b'! !

!OBColumnTest methodsFor: 'emulating' stamp: 'cwp 6/28/2006 00:42'!
requestor
	^ OBRequestor for: self! !

!OBColumnTest methodsFor: 'support' stamp: 'cwp 6/25/2006 13:26'!
setUp
	announcer _ OBAnnouncer new.
	column _ OBColumn 
				inPanel: self 
				metaNode: OBFakeNode metagraph
				node: (OBFakeNode parent: nil item: 'a').

	! !

!OBColumnTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:35'!
test01MenuIncludesCommands
	| menu invoked |
	invoked := false.
	(self addFactory: [invoked := true]) label: 'test service'.
	menu := MenuMorph new.
	column menu: menu.
	(menu itemWithWording: 'test service') doButtonAction.
	self assert: invoked! !

!OBColumnTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:35'!
test02KeystrokeInvokesCommand
	| invoked |
	invoked := false.
	(self addFactory: [invoked := true]) keystroke: $s.
	column keystroke: $s from: nil.
	self assert: invoked! !

TestCase subclass: #OBDefinitionPanelTest
	instanceVariableNames: 'announcer panel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBDefinitionPanelTest methodsFor: 'emulating' stamp: 'cwp 10/13/2006 09:30'!
announce: aClass 
	^ announcer announce: aClass! !

!OBDefinitionPanelTest methodsFor: 'emulating' stamp: 'cwp 10/13/2006 00:09'!
announcer
	^ announcer! !

!OBDefinitionPanelTest methodsFor: 'support' stamp: 'cwp 10/13/2006 00:18'!
assertMenu: aMenu hasItemSending: aSelector
	aMenu items anySatisfy: [:ea | ea selector = aSelector]! !

!OBDefinitionPanelTest methodsFor: 'emulating' stamp: 'cwp 11/2/2006 00:35'!
scanCommands: ann 
	ann 
		addFactory: ((OBPluggableService action: 
					[:node | 
					self assert: (node isKindOf: OBTextSelection).
					executed := true]) 
				label: 'test')! !

!OBDefinitionPanelTest methodsFor: 'support' stamp: 'cwp 10/13/2006 10:04'!
setUp
	announcer _ OBAnnouncer new.
	panel _ OBDefinitionPanel inBrowser: self.
	! !

!OBDefinitionPanelTest methodsFor: 'tests' stamp: 'cwp 10/14/2006 16:58'!
test01MenuHasEditingItems
	| menu |
	menu _ panel morph getMenu: false.
	self assertMenu: menu hasItemSending: #find.
	self assertMenu: menu hasItemSending: #findAgain.
	self assertMenu: menu hasItemSending: #setSearchString.
	self assertMenu: menu hasItemSending: #again.
	self assertMenu: menu hasItemSending: #undo.
	self assertMenu: menu hasItemSending: #copySelection.
	self assertMenu: menu hasItemSending: #cut.
	self assertMenu: menu hasItemSending: #paste.
	self assertMenu: menu hasItemSending: #pasteRecent.
	self assertMenu: menu hasItemSending: #accept.
	self assertMenu: menu hasItemSending: #cancel.! !

!OBDefinitionPanelTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:35'!
test02MenuIncludesCommands
	| menu |
	announcer observe: OBTextCommandScan
		do: [:ann | ann addFactory: (OBPluggableCommand new label: 'test')].
	menu := panel morph getMenu: false.
	self deny: (menu itemWithWording: 'test') isNil! !

!OBDefinitionPanelTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:35'!
test03CommandsGetExecuted
	| menu executed |
	executed := false.
	announcer observe: OBTextCommandScan
		do: 
			[:ann | 
			ann 
				addFactory: ((OBPluggableCommand action: [executed := true]) label: 'test')].
	menu := panel morph getMenu: false.
	(menu itemWithWording: 'test') doButtonAction.
	self assert: executed! !

!OBDefinitionPanelTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:36'!
test04InactiveCommandsAreHidden
	| menu |
	announcer observe: OBTextCommandScan
		do: 
			[:ann | 
			ann 
				addFactory: ((OBPluggableCommand action: [] active: [false]) label: 'test')].
	menu := panel morph getMenu: false.
	self assert: (menu itemWithWording: 'test') isNil! !

!OBDefinitionPanelTest methodsFor: 'tests' stamp: 'cwp 3/3/2007 22:37'!
test05SilentChangeAllowedIfNotDirty
	| ann |
	ann _ announcer announce: OBAboutToChangeSilently.
	self deny: ann isVetoed.! !

!OBDefinitionPanelTest methodsFor: 'tests' stamp: 'cwp 3/3/2007 23:08'!
test06SilentChangeVetoedIfDirty
	| ann morph |
	morph _ panel morph.
	morph hasUnacceptedEdits: true.
	ann _ announcer announce: OBAboutToChangeSilently.
	self assert: ann isVetoed.! !

TestCase subclass: #OBKeyBindingsTest
	instanceVariableNames: 'ptm message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBKeyBindingsTest methodsFor: 'asserting' stamp: 'cwp 10/31/2004 00:36'!
assert: evt sends: aSelector
	ptm keyStroke: evt.
	self assert: message notNil.
	self assert: message selector = aSelector.
	self assert: message arguments size = 1.
	self assert: message arguments first = #OBBrowser.! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/30/2004 23:58'!
browseIt: aSelector
	message _ self thisMessage.
	^ true! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/31/2004 00:39'!
implementorsOfIt: aSelector
	message _ self thisMessage.
	^ true! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:08'!
ksCmdB
	^ self modifier: 64 keycode: 98! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:08'!
ksCmdM
	^ self modifier: 64 keycode: 109! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:08'!
ksCmdN
	^ self modifier: 64 keycode: 110! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:09'!
ksCmdShiftE
	^ self modifier: 72 keycode: 69
! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:09'!
ksCmdShiftN
	^ self modifier: 72 keycode: 78! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:09'!
ksCmdShiftW
	^ self modifier: 72 keycode: 87! !

!OBKeyBindingsTest methodsFor: 'keystrokes' stamp: 'cwp 10/31/2004 01:07'!
modifier: mod keycode: code
	| string |
	string := 'keystroke 988180 ', mod asString, ' ', code asString.
	^ KeyboardEvent readFrom: string readStream! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/31/2004 00:49'!
referencesToIt: aSelector
	message := self thisMessage.
	^ true! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/30/2004 23:26'!
selection
	^ 1 to: 9! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/31/2004 00:25'!
sendersOfIt: aSelector
	message := self thisMessage.
	^ true! !

!OBKeyBindingsTest methodsFor: 'running' stamp: 'cwp 10/30/2004 22:05'!
setUp
	ptm := (OBPluggableTextMorph
			on: self
			text: #text
			accept: #accept:notifying:
			readSelection: #selection
			menu: #menu:shifted:)
				font: Preferences standardCodeFont;
				yourself! !

!OBKeyBindingsTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 00:33'!
testBrowseIt
	self assert: self ksCmdB sends: #browseIt:! !

!OBKeyBindingsTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 00:35'!
testImplementorsOfIt
	self assert: self ksCmdM sends: #implementorsOfIt:! !

!OBKeyBindingsTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 00:44'!
testReferencesToIt
	self assert: self ksCmdShiftN sends: #referencesToIt:! !

!OBKeyBindingsTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 00:35'!
testSendersOfIt
	self assert: self ksCmdN sends: #sendersOfIt:! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/30/2004 23:26'!
text
	^ 'OBBrowser'! !

!OBKeyBindingsTest methodsFor: 'callbacks' stamp: 'cwp 10/30/2004 23:57'!
thisMessage
	| context args |
	context := thisContext sender.
	args := Array new: context size.
	1 to: args size do: [:i | args at: i put: (context at: 1)].
	^ Message 
		selector: context method selector
		arguments: args ! !

TestCase subclass: #OBOpenTest
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

OBOpenTest subclass: #OBLibraryOpenTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBLibraryOpenTest methodsFor: 'accessing' stamp: 'cwp 1/21/2007 23:42'!
metagraph
	| fake |
	fake _ OBMetaNode new.
	fake childAt: #children put: fake.
	^ fake! !

!OBLibraryOpenTest methodsFor: 'tests' stamp: 'avi 9/17/2005 01:16'!
testGraphRootSelection
	| parent child |
	parent _ OBFakeNode parent: nil item: 'parent'.
	child _ OBFakeNode parent: parent item: 'a'.
	self create: [OBBrowser 
					metaNode: self metagraph
					root: parent
					selection: child].
	self shouldnt: [browser navigationPanel] raise: Error! !

!OBLibraryOpenTest methodsFor: 'tests' stamp: 'avi 9/17/2005 01:17'!
testGraphRootSelectionPanels
	| parent child panels |
	parent _ OBFakeNode parent: nil item: 'parent'.
	child _ OBFakeNode parent: parent item: 'a'.
	panels _ {OBColumnPanel new. OBDefinitionPanel new}.
	self create: [OBBrowser 
					metaNode: self metagraph
					root: parent
					selection: child
					panels: panels].
	self assert: browser navigationPanel minPanes = 1.
	self assert: browser navigationPanel maxPanes = 1.
	self assert: browser root = parent.
	self assert: browser currentNode = child.
	self assert: browser panels size = panels size.
	self assert: (browser panels includesAllOf: panels)! !

!OBOpenTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/5/2004 15:55'!
isAbstract
	^ self name = #OBOpenTest! !

!OBOpenTest methodsFor: 'actions' stamp: 'cwp 12/5/2004 15:54'!
create: aBlock
	self 
		shouldnt: [browser _ aBlock value]
		raise: OBBrowseRequest! !

!OBOpenTest methodsFor: 'actions' stamp: 'cwp 12/5/2004 15:52'!
open: aBlock
	[aBlock value]
		on: OBBrowseRequest
		do: [:n | browser _ n browser].
	self assert: browser notNil! !

TestCase subclass: #OBPaneLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBPaneLayoutTest methodsFor: 'callbacks' stamp: 'cwp 11/2/2004 00:37'!
buttonMorph
	^ RectangleMorph new
		color: Color red;
		yourself! !

!OBPaneLayoutTest methodsFor: 'callbacks' stamp: 'cwp 11/2/2004 00:34'!
listMorph
	^ RectangleMorph new
! !

!OBPaneLayoutTest methodsFor: 'testing' stamp: 'cwp 11/7/2004 00:13'!
testButtonPlacement
	| pane button |
	pane := OBPane forColumn: self withFilter: self.
	pane bounds: (0@0 corner: 200@400).
	button := pane submorphs at: 1.
	self assert: button top = 377.
	self assert: button bottom = 400.
	self assert: button left = pane left.
	self assert: button right = pane right.! !

TestCase subclass: #OBPaneScrollerTest
	instanceVariableNames: 'paneCount scroller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBPaneScrollerTest methodsFor: 'actions' stamp: 'cwp 11/2/2004 00:00'!
createPane
	^ RectangleMorph new
		bounds: (10@10 corner: 20@20);
		yourself! !

!OBPaneScrollerTest methodsFor: 'actions' stamp: 'cwp 11/21/2004 22:40'!
createScroller
	scroller := OBPaneScroller withModel: self.
	scroller bounds: (10 @ 420 extent: 600 @ 160)! !

!OBPaneScrollerTest methodsFor: 'callbacks' stamp: 'cwp 11/21/2004 12:55'!
panes
	^ ((1 to: paneCount) collect: [:i | self createPane]) asOrderedCollection! !

!OBPaneScrollerTest methodsFor: 'callbacks' stamp: 'cwp 11/23/2004 01:37'!
reclaimPanes
	^ scroller panes size - 4! !

!OBPaneScrollerTest methodsFor: 'callbacks' stamp: 'cwp 11/17/2004 23:39'!
sizing
	^ 4! !

!OBPaneScrollerTest methodsFor: 'tests' stamp: 'cwp 11/21/2004 22:40'!
testPaneHeightNoScrollBar
	paneCount := 4.
	self createScroller.
	self assert: scroller paneHeight = 160! !

!OBPaneScrollerTest methodsFor: 'tests' stamp: 'cwp 11/21/2004 22:40'!
testPaneHeightWithScrollBar
	paneCount := 5.
	self createScroller.
	self assert: scroller paneHeight = 147! !

!OBPaneScrollerTest methodsFor: 'tests' stamp: 'cwp 11/23/2004 01:38'!
testPaneReclamation
	paneCount := 6.
	self createScroller.
	scroller submorphs first setValue: 0.2.
	scroller step.
	self assert: scroller panes size = 4! !

!OBPaneScrollerTest methodsFor: 'tests' stamp: 'cwp 11/21/2004 23:11'!
testResizeUpdatesPaneHeight
	paneCount := 4.
	self createScroller.
	self assert: scroller panes first height = 160.
	scroller bounds: (scroller bounds outsetBy: 1).
	self assert: scroller panes first height = 162! !

!OBPaneScrollerTest methodsFor: 'tests' stamp: 'cwp 11/21/2004 23:09'!
testResizeUpdatesPaneWidth
	paneCount := 4.
	self createScroller.
	self assert: scroller panes first width = 147.
	scroller bounds: (scroller bounds outsetBy: 2).
	self assert: scroller panes first width = 148! !

TestCase subclass: #OBPanelLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBPanelLayoutTest methodsFor: 'asserting' stamp: 'cwp 9/13/2005 21:56'!
assert: aNumber isNear: aNumber2 
	self assert: (aNumber - aNumber2) abs <= self tolerance! !

!OBPanelLayoutTest methodsFor: 'asserting' stamp: 'cwp 2/25/2007 21:18'!
assertFrame: frame hasFractions: fraction andOffsets: offset
	self assert: frame leftFraction = fraction left.
	self assert: frame topFraction = fraction top.
	self assert: frame rightFraction = fraction right.
	self assert: frame bottomFraction = fraction bottom.
	
	self assert: frame leftOffset isNear: offset left.
	self assert: frame topOffset isNear: offset top.
	self assert: frame rightOffset isNear: offset right.
	self assert: frame bottomOffset isNear: offset bottom.
! !

!OBPanelLayoutTest methodsFor: 'accessing' stamp: 'cwp 11/7/2004 21:27'!
metaNode
	^ OBFakeNode metagraph! !

!OBPanelLayoutTest methodsFor: 'accessing' stamp: 'cwp 8/25/2004 21:44'!
node
	^ OBFakeNode new! !

!OBPanelLayoutTest methodsFor: 'testing' stamp: 'cwp 9/13/2005 21:59'!
testNavPanel
	| window |
	window _ self windowWithPanels: {OBColumnPanel}.
	self assert: window submorphs size >= 2.
	self assert: window submorphs second knownName = 'scroller'.
	self
		assertFrame: window submorphs second layoutFrame
		hasFractions: (0@0 corner: 1@1)
		andOffsets: (0@0 corner: 0@0)! !

!OBPanelLayoutTest methodsFor: 'testing' stamp: 'cwp 3/3/2007 00:40'!
testTextAndButtonPanels
	| window |
	window _ self windowWithPanels: {OBColumnPanel. OBFixedButtonPanel. OBDefinitionPanel}.
	self
		assertFrame: window submorphs second layoutFrame
		hasFractions: (0@0 corner: 1@0.5)
		andOffsets: (0@0 corner: 0@0).
	self
		assertFrame: window submorphs third layoutFrame
		hasFractions: (0@0.5 corner: 1@0.5)
		andOffsets: (0@0 corner: 0@25).
	self
		assertFrame: window submorphs fourth layoutFrame
		hasFractions: (0@0.5 corner: 1@1)
		andOffsets: (0@25 corner: 0@0)! !

!OBPanelLayoutTest methodsFor: 'testing' stamp: 'cwp 3/3/2007 00:41'!
testTextPanel
	| window |
	window _ self windowWithPanels: {OBColumnPanel. OBDefinitionPanel}.
	self assert: window submorphs size >= 3.
	self assert: window submorphs second knownName = 'scroller'.
	self
		assertFrame: window submorphs second layoutFrame
		hasFractions: (0@0 corner: 1@0.5)
		andOffsets: (0@0 corner: 0@0).
	self
		assertFrame: window submorphs third layoutFrame
		hasFractions: (0@0.5 corner: 1@1)
		andOffsets: (0@0 corner: 0@0)! !

!OBPanelLayoutTest methodsFor: 'testing' stamp: 'cwp 3/3/2007 00:42'!
testTwoTextPanels
	"Yeah, ok, this is a bit ridiculous"
	
	| window |
	window _ self windowWithPanels: {OBColumnPanel. OBDefinitionPanel. OBDefinitionPanel}.	
	self
		assertFrame: window submorphs second layoutFrame
		hasFractions: (0@0 corner: 1@(1/3))
		andOffsets: (0@0 corner: 0@0).
	self
		assertFrame: window submorphs third layoutFrame
		hasFractions: (0@(1/3) corner: 1@(2/3))
		andOffsets: (0@0 corner: 0@0).
	self
		assertFrame: window submorphs fourth layoutFrame
		hasFractions: (0@(2/3) corner: 1@1)
		andOffsets: (0@0 corner: 0@0)! !

!OBPanelLayoutTest methodsFor: 'testing' stamp: 'cwp 3/3/2007 00:41'!
testUpsideDown
	| window |
	window _ self windowWithPanels: {OBDefinitionPanel. OBColumnPanel}.
	self assert: window submorphs size >= 3.
	self assert: window submorphs third knownName = 'scroller'.
	self
		assertFrame: window submorphs second layoutFrame
		hasFractions: (0@0 corner: 1@0.5)
		andOffsets: (0@0 corner: 0@0).
	self
		assertFrame: window submorphs third layoutFrame
		hasFractions: (0@0.5 corner: 1@1)
		andOffsets: (0@3 corner: 0@0).! !

!OBPanelLayoutTest methodsFor: 'accessing' stamp: 'cwp 9/13/2005 21:55'!
tolerance
	^ 4! !

!OBPanelLayoutTest methodsFor: 'accessing' stamp: 'cwp 12/5/2004 18:24'!
windowWithPanels: panelClasses
	| browser panels |
	panels := panelClasses collect: [:ea | ea new].
	browser _ OBBrowser 
				metaNode: self metaNode 
				root: self node
				selection: nil
				panels: panels. 
	^ browser morph
! !

TestCase subclass: #OBPluggableCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBPluggableCommandTest methodsFor: 'emulating' stamp: 'cwp 7/9/2006 12:52'!
height
	^ 16! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:39'!
test01ExecuteEvaluatesAction
	| called factory command |
	called _ false.
	factory _ OBPluggableCommand action: [called _ true].
	command _ factory on: nil for: nil.
	command execute.
	self assert: called.! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:39'!
test02ActionCanBeAMessageSend
	| called factory send command |
	called _ false.
	send _ MessageSend receiver: [called _ true] selector: #value.
	factory _ OBPluggableCommand action: send.
	command _ factory on: nil for: nil.
	command execute.
	self assert: called.! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:40'!
test03ActionReceivesRequestor
	| factory requestor command |
	requestor _ nil.
	factory _ OBPluggableCommand action: [:arg1 :arg2 | requestor _ arg2].
	command _ factory on: nil for: self.
	command execute.
	self assert: requestor == self.! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:40'!
test03ActionRecievesNode
	| factory node command |
	node _ nil.
	factory _ OBPluggableCommand action: [:arg1 :arg2 | node _ arg1].
	command _ factory on: self for: nil.
	command execute.
	self assert: node == self.! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:40'!
test04ConditionExecutesByDefault
	| factory command |
	factory _ OBPluggableCommand action: [].
	command _ factory on: nil for: nil.
	self assert: command isActive
	! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:40'!
test06MenuItemExecutesAction
	| menu factory called command |
	called _ false.
	menu _ MenuMorph new.
	factory _ OBPluggableCommand action: [called _ true].
	command _ factory on: nil for: nil.
	command addItemToMenu: menu.
	menu items first doButtonAction.
	self assert: called! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:40'!
test07MenuItemEnabledByDefault
	| menu factory command |
	menu _ MenuMorph new.
	factory _ OBPluggableCommand new.
	command _ factory on: nil for: nil.
	command addItemToMenu: menu.
	self assert: menu items first isEnabled! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:41'!
test08MenuItemReflectsCondition
	
	| factory command |
	factory _ OBPluggableCommand new enabled: [false].
	command _ factory on: nil for: self.
	self deny: (command isEnabled).
	! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:41'!
test09MenuReflectsLabel
	| menu factory command |
	menu _ MenuMorph new.
	factory _ OBPluggableCommand new label: 'a fine factory'.
	command _ factory on: nil for: self.
	command addItemToMenu: menu.
	self assert: menu items first contents = 'a fine factory'! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:41'!
test10MenuDisplaysKeystroke
	| menu factory command |
	menu _ MenuMorph new.
	factory _ OBPluggableCommand new 
				label: 'a fine factory';
				keystroke: $f.
	command _ factory on: nil for: self.
	command addItemToMenu: menu.
	self assert: menu items first contents = 'a fine factory (f)'! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:41'!
test11MenuDisplaysIcon
	| menu factory pref command |
	pref _ Preferences menuWithIcons.
	[Preferences enableGently: #menuWithIcons.
	menu _ MenuMorph new.
	factory _ OBPluggableCommand new 
				label: 'a fine factory';
				icon: self.
	command _ factory on: nil for: self.
	command addItemToMenu: menu.
	self assert: menu lastItem icon == self]
		ensure: [Preferences setPreference: #menuWithIcons toValue: pref]! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:42'!
test12ButtonCreatedWithLabel
	| factory button |
	factory _ OBPluggableCommand new.
	factory buttonLabel: 'serv'.
	button _ factory buttonMorph.
	self assert: (button isKindOf: PluggableButtonMorph).
	self assert: button label contents = 'serv'! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:42'!
test13CommandIsMenuOnlyByDefault
	| factory |
	factory := OBPluggableCommand new.
	self deny: factory wantsButton! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:42'!
test14CommandWithButtonLabelWantsButton
	| factory |
	factory := OBPluggableCommand new.
	factory buttonLabel: 'serv'.
	self assert: factory wantsButton! !

!OBPluggableCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 00:42'!
test15CondReceivesRequestor
	| factory requestor command |
	requestor _ nil.
	factory _ OBPluggableCommand action: [] active: [:n :r | requestor _ r].
	command _ factory on: factory for: self.
	command isActive.
	self assert: requestor == self! !

!OBPluggableCommandTest methodsFor: 'emulating' stamp: 'cwp 7/9/2006 12:52'!
width
	^ 16! !

TestCase subclass: #OBProtocolMockTest
	instanceVariableNames: 'mock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBProtocolMockTest methodsFor: 'running' stamp: 'cwp 2/13/2004 01:15'!
setUp
	mock _ OBProtocolMock new.! !

!OBProtocolMockTest methodsFor: 'asserting' stamp: 'cwp 2/13/2004 01:17'!
shouldFail: aBlock
	self should: aBlock raise: TestResult failure
				
					! !

!OBProtocolMockTest methodsFor: 'testing' stamp: 'cwp 2/28/2004 17:17'!
testAnswers
	| one two three |
	mock 
		expect: [:stub | stub int; int; int];
		answer: #(1 2 3);
		examine: [:stub | 	one _ stub int.
						two _ stub int.
						three _ stub int].
		self assert: one = 1.
		self assert: two = 2.
		self assert: three = 3! !

!OBProtocolMockTest methodsFor: 'testing' stamp: 'cwp 3/14/2004 15:39'!
testAnswersRecorder
	| one two three |
	mock 
		expect: [:stub | stub int; int; int; foo];
		answer: #(1 2);
		examine: [:stub | one _ stub int.
						two _ stub int.
						three _ stub int.
						three foo].
		self assert: one = 1.
		self assert: two = 2.! !

!OBProtocolMockTest methodsFor: 'testing' stamp: 'cwp 2/13/2004 01:17'!
testArgFailure
	mock expect: [:stub | stub foo: #bar].
	self shouldFail: [mock examine: [:stub | stub foo: #baz]]
					! !

!OBProtocolMockTest methodsFor: 'testing' stamp: 'cwp 2/13/2004 01:17'!
testExtraFailure
	mock expect: [:stub | stub foo].
	self shouldFail: [mock examine: [:stub | stub foo; bar]]! !

!OBProtocolMockTest methodsFor: 'testing' stamp: 'cwp 2/13/2004 01:18'!
testMissingFailure
	mock expect: [:stub | stub foo; bar].
	self shouldFail: [mock examine: [:stub | stub foo]]! !

!OBProtocolMockTest methodsFor: 'testing' stamp: 'cwp 2/13/2004 01:44'!
testNoExceptionFailure
	mock 
		resume: Notification with: true;
		expect: [:stub | stub truth: true].
	self shouldFail: [mock examine: [:stub | stub truth: true]] ! !

!OBProtocolMockTest methodsFor: 'testing' stamp: 'cwp 2/13/2004 01:20'!
testResume
	mock 
		resume: Notification with: true;
		expect: [:stub | stub truth: true];
		examine: [:stub | stub truth: Notification signal]! !

!OBProtocolMockTest methodsFor: 'testing' stamp: 'cwp 2/13/2004 01:18'!
testSelectorFailure
	mock expect: [:stub | stub foo].
	self shouldFail: [mock examine: [:stub | stub bar]]
	! !

!OBProtocolMockTest methodsFor: 'testing' stamp: 'cwp 2/13/2004 01:18'!
testSuccess
	mock expect: [:stub | stub foo; foo: #bar].
	mock examine: [:stub | stub foo; foo: #bar]
				
					! !

!OBProtocolMockTest methodsFor: 'testing' stamp: 'cwp 2/29/2004 16:05'!
testTooManyExceptionsFailure
	mock 
		resume: Notification with: true;
		expect: [:stub | stub truth: true].
	self should:  [mock examine: [:stub | stub truth: Notification signal. Notification signal]]
		raise: Exception! !

!OBProtocolMockTest methodsFor: 'testing' stamp: 'cwp 2/28/2004 22:09'!
testWrongExceptionFailure
	mock 
		resume: Notification with: true;
		expect: [:stub | stub truth: true].
	self should: [mock examine: [:stub | stub truth: Error signal]] 
		raise: Error! !

TestCase subclass: #OBTextSelectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBTextSelectionTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2006 20:17'!
test01Text
	| selection |
	selection _ OBTextSelection on: (3 to: 5) inText: 'abcdefghijk'.
	self assert: selection text = 'cde'.
! !

!OBTextSelectionTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2006 20:17'!
test02FullText
	| selection |
	selection _ OBTextSelection on: (3 to: 5) inText: 'abcdefghijk'.
	self assert: selection fullText = 'abcdefghijk'.! !

!OBTextSelectionTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2006 20:26'!
test03Selector
	| selection text |
	text _ 'self foo: #a bar: #b.  '.
	selection _ OBTextSelection 
					on: (1 to: text size) 
					inText: text.
	self assert: selection selector = #foo:bar:

! !

Object subclass: #OBProtocolMock
	instanceVariableNames: 'messages answers exceptions recorder isRecording'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBProtocolMock methodsFor: 'recording' stamp: 'cwp 3/14/2004 15:39'!
answer
	^ answers 
		ifNil: [self]
		ifNotNil: [answers isEmpty 
							ifTrue: [self recorder]
							ifFalse: [answers removeFirst]]! !

!OBProtocolMock methodsFor: 'examining' stamp: 'cwp 2/28/2004 17:22'!
answer: anObjectOrCollection
	answers ifNil: [answers _ OrderedCollection new].
	anObjectOrCollection isCollection
		ifTrue: [answers addAll: anObjectOrCollection]
		ifFalse: [answers add: anObjectOrCollection]! !

!OBProtocolMock methodsFor: 'asserting' stamp: 'cwp 2/13/2004 01:29'!
assert: aBoolean
	self assert: aBoolean message: 'Assertion failed'! !

!OBProtocolMock methodsFor: 'asserting' stamp: 'cwp 2/13/2004 01:28'!
assert: aBoolean message: aString
	aBoolean ifFalse: [self fail: aString]! !

!OBProtocolMock methodsFor: 'asserting' stamp: 'cwp 2/13/2004 01:30'!
deny: aBoolean
	self assert: aBoolean not! !

!OBProtocolMock methodsFor: 'asserting' stamp: 'cwp 2/13/2004 01:29'!
deny: aBoolean message: aString
	self assert: aBoolean not message: aString! !

!OBProtocolMock methodsFor: 'examining' stamp: 'cwp 3/14/2004 15:35'!
do: aBlock
	^ aBlock value: self recorder! !

!OBProtocolMock methodsFor: 'examining' stamp: 'cwp 2/13/2004 01:41'!
examine: aBlock
	[self do: aBlock]
		on: Exception
		do: [:exception | self handleException: exception].

	self assert: messages isEmpty
		message: 'Expected message not sent'.
	self deny: (exceptions notNil and: [exceptions notEmpty])
		message: 'Expected exception not raised'! !

!OBProtocolMock methodsFor: 'examining' stamp: 'cwp 2/13/2004 00:51'!
expect: aBlock
	isRecording _ true.
	messages _ OrderedCollection new.
	self do: aBlock.
	isRecording _ false.! !

!OBProtocolMock methodsFor: 'asserting' stamp: 'cwp 7/9/2006 01:15'!
fail: aString
	^ TestResult signalFailureWith: aString! !

!OBProtocolMock methodsFor: 'examining' stamp: 'cwp 2/29/2004 15:49'!
handleException: exception
	| expectation |
	(exception isKindOf: TestFailure) ifTrue: [exception pass].
	(exceptions isNil or: [exceptions isEmpty]) ifTrue: [exception pass].
	expectation _ exceptions removeFirst.
	exception class = expectation first ifFalse: [exception pass].
	exception isResumable ifTrue: [expectation second
									ifNil: [exception resume]
									ifNotNil: [exception resume: expectation second]]! !

!OBProtocolMock methodsFor: 'recording' stamp: 'cwp 2/28/2004 17:26'!
message: aMessage
	| expected |
	isRecording ifTrue: [messages add: aMessage. ^ self].
	
	self 
		deny: messages isEmpty 
		message: 'No more messages expected'.
	expected _ messages removeFirst.
	self assert: (expected sends: aMessage selector)
		message: 'Unexpected message'.
	self assert: expected arguments = aMessage arguments
		message: 'Incorrect arguments'.
		
	^ self answer! !

!OBProtocolMock methodsFor: 'recording' stamp: 'cwp 3/14/2004 15:36'!
recorder
	^ recorder ifNil: [recorder _ (OBMessageRecorder forMock: self)]! !

!OBProtocolMock methodsFor: 'recording' stamp: 'cwp 2/28/2004 22:04'!
resume: aNotificationClass 
	^ self resume: aNotificationClass with: nil! !

!OBProtocolMock methodsFor: 'recording' stamp: 'cwp 2/13/2004 00:41'!
resume: aNotificationClass with: aValue
	exceptions ifNil: [exceptions _ OrderedCollection new].
	exceptions add: (Array with: aNotificationClass with: aValue)! !

OBNode subclass: #OBFakeNode
	instanceVariableNames: 'item parent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Core'!

!OBFakeNode class methodsFor: 'browsing' stamp: 'cwp 3/12/2007 23:47'!
metagraph
	| fake |
	fake _ OBMetaNode new.
	fake childAt: #children put: fake.
	^ fake! !

!OBFakeNode class methodsFor: 'instance creation' stamp: 'cwp 12/15/2003 22:06'!
parent: aFakeNode item: aString
	^ self new parent: aFakeNode; item: aString! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 6/4/2006 13:26'!
actions
	^ Array 
		with: (self action: #createZ withLabel: 'create z')
		with: (self action: #beZ withLabel: 'become z')
		with: (self action: #delete withLabel: 'delete')
		with: (self action: #deleteRoot withLabel: 'delete root')! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 3/13/2007 00:33'!
adopt: aNode
	aNode parent removeChild: aNode.
	aNode parent: self.
	children _ self children copyWith: aNode.
	^ aNode! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 3/13/2007 00:08'!
beZ
	item _ 'z'.
	! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 1/23/2004 21:42'!
children
	^ children 
		ifNil: [children _ (self item endsWith: 'c')
					ifTrue: [Array new]
					ifFalse: [#($a $b $c) collect: [:i | OBFakeNode parent: self item: i asString]]]! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 3/13/2007 00:33'!
createZ
	^ self adopt: (OBFakeNode parent: self item: 'z')! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 3/13/2007 00:20'!
delete
	parent ifNotNil: [parent removeChild: self].
	! !

!OBFakeNode methodsFor: 'drag and drop' stamp: 'cwp 3/13/2007 00:43'!
dropOnFakeNode: aNode
	aNode adopt: self.
	aNode signalSelection! !

!OBFakeNode methodsFor: 'drag and drop' stamp: 'cwp 3/2/2004 21:40'!
dropSelector
	^ #dropOnFakeNode:! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/5/2004 16:16'!
isAncestorOf: aNode
	| ancestor |
	aNode name = self name ifTrue: [^ true].
	ancestor _ aNode.
	[ancestor isNil]
		whileFalse: [ancestor == self ifTrue: [^ true].
					ancestor _ ancestor parent].
	^ false! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/7/2003 19:18'!
item
	^ item ifNil: [item _ '']! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/7/2003 19:09'!
item: aSymbol
	item _ aSymbol! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:05'!
name
	^ self parentName, self item ! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 2/25/2004 21:49'!
parent
	^ parent! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/15/2003 22:01'!
parent: aFakeNode
	parent _ aFakeNode! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/15/2003 22:04'!
parentName
	^ (parent ifNil: [''] ifNotNil: [parent name])! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 2/25/2004 21:53'!
removeChild: aFakeNode
	children _ self children copyWithout: aFakeNode! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 3/13/2007 00:24'!
root
	| node |
	node _ self parent.
	[node parent notNil] whileTrue: [node _ node parent].
	^ node! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:03'!
text
	^ self name! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 9/18/2005 14:58'!
text: aText
	self item:( aText asString allButFirst: (self parentName size)).
	self demandSelection.
	^ true! !
